(((kind "manual-section") (section-title "This section contains the XML declaration

") (section-body "")) ((kind "manual-page") (description "Return the xml declaration
") (title "xml-declaration") (form (xml-declaration))) ((kind "manual-section") (section-title "Configuration part.") (section-body "The variables and functions in this part controls the checking, validation, and error reporting of the XML mirror functions.

")) ((kind "manual-page") (description "A boolean variable which controls the checking of tag attributes.
If true, check the tag (element) attributes against the attributes as defined in the DTD file.
The default value is true.
") (title "xml-check-attributes?") (form xml-check-attributes?)) ((kind "manual-page") (description "A boolean variable that controls the XML validation.
If true, do validate the generated XML document against the DTD.
The default value is true.
") (title "xml-validate-contents?") (form xml-validate-contents?)) ((kind "manual-page") (description "A boolean variable that controls the check of XML language overlap.
If true, check that that no elements are used via ambiguous simple names.
") (title "xml-check-language-overlap?") (form xml-check-language-overlap?)) ((kind "manual-page") (cross-references (reference "Character transformation table" "table" "../../../man/laml.html#html-char-transformation-table")) (description "A boolean variable that controls whether CDATA (Character data) are transformed
through the HTML/XML character transformation table. The default value is true.") (title "xml-transliterate-character-data?") (form xml-transliterate-character-data?)) ((kind "manual-page") (description "A list of elements for which content data - CDATA - is never transformed.
As an example, it will often cause problems if scripts are being modified by means of transliterations using
the HTML character transformation table.
A list of strings.
Defaults to the empty list
You can redefine it after the document style has been loaded.
XML language specific.
") (title "xml-non-transliteration-elements") (form xml-non-transliteration-elements)) ((kind "manual-page") (description "How many characters of the validation error messages to be presented.
") (title "xml-error-truncation-length") (form xml-error-truncation-length)) ((kind "manual-section") (section-title "Other Constants.") (section-body "")) ((kind "manual-page") (description "The symbolic name of explicit white space suppress
") (title "_") (form _)) ((kind "manual-section") (section-title "AST functions.") (section-body "In this section we document the functions that work on abstract syntax trees.
All the XML mirror functions return abstract syntax trees, which need to be transformed
to text before they can be presented. The function xml-render performs this transformation.

")) ((kind "manual-page") (description "A boolean variable that controls whether or not we check the internal soundness of ASTs.
If the basic mirror is used directly, it makes good sense to set this variable to #t.
Else we recommend a #f value.
") (title "check-ast-constituents?") (form check-ast-constituents?)) ((kind "manual-page") (description "Make an AST given element-name, contents, a property list of attributes, a kind (single/double)
an an XML language name. 
elment-name must be a string or symbol.
The parameter contents may be a list of subtrees. It may also be or an element which satisfies
either ast?, cdata? or forced-white-space?. In these cases, we embed the single element into a list.
attributes is the list of attributes on property list format (such as '(a1 \"v1\" a2 \"v2\")). 
attribute names are always symbols, and attribute values are always strings.
Kind is either the symbol double or single.
Language is a symbol or string that represent the XML language name.
") (title "make-ast") (form (make-ast element-name contents attributes kind language))) ((kind "manual-page") (description "Return the root element name of ast.") (pre-condition "ast is an abstract syntax tree that satisfies the ast? predicate") (title "ast-element-name") (form (ast-element-name ast))) ((kind "manual-page") (description "Return the list of substrees of ast.") (pre-condition "ast is an abstract syntax tree that satisfies the ast? predicate") (title "ast-subtrees") (form (ast-subtrees ast))) ((kind "manual-page") (description "Return the list of attributes of ast, on property list format.") (pre-condition "ast is an abstract syntax tree that satisfies the ast? predicate") (title "ast-attributes") (form (ast-attributes ast))) ((kind "manual-page") (description "Return the kind of the ast. It is either the symbol single or double.
Tells whether the ast is to be rendered as a single or double tag.") (pre-condition "ast is an abstract syntax tree that satisfies the ast? predicate") (title "ast-kind") (form (ast-kind ast))) ((kind "manual-page") (description "Return the language of teh ast (a symbol).") (pre-condition "ast is an abstract syntax tree that satisfies the ast? predicate") (title "ast-language") (form (ast-language ast))) ((kind "manual-page") (description "Is the parameter x an AST
") (title "ast?") (form (ast? x))) ((kind "manual-page") (description "Is the parameter x CDATA") (form "(cdata? x)") (title "cdata?")) ((kind "manual-page") (description "Is the parameter x either an ast or a contents string.
") (title "contents-data?") (form (contents-data? x))) ((kind "manual-page") (description "Is the parameter x a white space mark.
") (title "forced-white-space?") (form (forced-white-space? x))) ((kind "manual-page") (description "Is the parameter x white space related?") (form "(white-space-related? x)") (title "white-space-related?")) ((kind "manual-section") (section-title "XML language registration and language related bookkeeping.") (section-body "

")) ((kind "manual-page") (description "The list of names (symbols) which causes name clashes relative to 
the current set of languages in use.
Assigned by register-xml-in-laml-language.
Thus, this variable is always up-to-date in between registrations of languages.
Be careful not to redefine this variable by double loading this file.
") (title "xml-in-laml-name-clashes") (form xml-in-laml-name-clashes)) ((kind "manual-page") (description "Register that language (the first parameter) is an XML language in use in the current LAML session.
The first parameter, language, is a symbol.
The second parameter, language-map, is the language map of the language.
As a precondition is a assumed that we do not register the same language more than once.
") (title "register-xml-in-laml-language") (form (register-xml-in-laml-language language language-map))) ((kind "manual-page") (description "Return the language map of language.
If language is not registered via register-xml-in-laml-language, return #f.
The parameter language is a symbol.
") (title "language-map-of") (form (language-map-of language))) ((kind "manual-page") (description "is language in use - is it registered as an xml-in-laml language?
") (title "language-in-use?") (form (language-in-use? language))) ((kind "manual-page") (description "Return the list of language in used, as registered by register-xml-in-laml-language.
") (title "languages-in-use") (form (languages-in-use))) ((kind "manual-page") (description "Return the element names of language, as defined by its language map.
") (title "element-names-of-language") (form (element-names-of-language language))) ((kind "manual-page") (description "Is name involed in a name clash among the registered xml-in-laml languages?
") (title "causes-xml-in-laml-name-clash?") (form (causes-xml-in-laml-name-clash? name))) ((kind "manual-section") (section-title "The language map.") (section-body "The language map is a mapping that allows us to access the element mirror functions independent of
any name clash. 
In this version the language map is an association list from element names (symbols) to function objects.
In the longer run, it should be more efficient search structure.

")) ((kind "manual-page") (description "Return the mirror function based on element-name from language map.
Return #f if no mirror function exists in the map.
The parameter element-name is either a symbol or a string.
") (title "get-mirror-function") (form (get-mirror-function language-map element-name))) ((kind "manual-page") (description "Update the language map by the association of element-name and mirror function.
Returns the updated map.
The parameter element-name is either a symbol or a string.
Causes an error if there already is an entry for element-name
") (title "put-mirror-function") (form (put-mirror-function language-map element-name mirror-function))) ((kind "manual-section") (section-title "Mirror generation functions.") (section-body "The functions in this sections are the important and 'heavy' mirror generation functions.

")) ((kind "manual-page") (description "The central function which 'sorts out' the parameters of the mirror functions.
Returns a cons cell of contents and attributes.
") (title "xml-sort-tag-parameters") (form (xml-sort-tag-parameters parameters tag-name))) ((kind "manual-page") (description "Return an XML mirror surface function, in which textual content parameters and attribute
value pairs can be given in a very liberal fashion.
The parameter validation-procedure is the procedure that validates all aspects of the application of the element mirror function.
The parameter tag-name is a string which represents the name of the tag (used for error message purposes).
The paramter single-double-kind is either the symbol single, double or possible-single.
The paramter language defines the language in use (a symbol).
The parameter overlap-check? controls whether to check for name clashes in between the registered XML-in-LAML languages.
The parameter action-procedure serves both as a boolean and a procedure.
  If non-false, the parameter servers as action procedure, which will receive the AST for action purposes.
") (title "generate-xml-mirror-function") (form (generate-xml-mirror-function validation-procedure tag-name single-double-kind language overlap-check? action-procedure))) ((kind "manual-section") (section-title "Contents validation.") (section-body "
The definitions in this section is used by the validation procedures, which are specific
for each supported XML language

")) ((kind "manual-page") (description "Return a predicate which checks whether the contents matches one or more instances from element-constituent-list.
Element constituent-list is a list of strings, namely element tag names or
\"#PCDATA\".
A true results means OK - no error
Avoid a O(n^2) algorithm here in the final implementation
") (title "one-or-more") (form (one-or-more . element-constituent-list))) ((kind "manual-page") (description "Return a predicate which checks whether the contents matches zero or more instances from element-constituent-list
") (title "zero-or-more") (form (zero-or-more . element-constituent-list))) ((kind "manual-page") (description "Return a predicate which checks whether the contents match the sequential rhs-elements.
rhs-elements is a list of strings or symbols, which symbols represent optionals.
Example (sequence-with-optionals \"xxx\" \"yyy\" 'zzz) corresponds to
        xxx, yyy, zzz?
We assume that rhs-elements, in the starting point, always contains at least one element.
") (title "sequence-with-optionals") (form (sequence-with-optionals . rhs-elements))) ((kind "manual-page") (description "A predicate which checks whether the contents is PCDATA.
") (title "pcdata-checker") (form (pcdata-checker contents))) ((kind "manual-section") (section-title "Attribute checking.") (section-body "
The definitions in this section is used by the validation procedures, which are specific
for each supported XML language 

")) ((kind "manual-page") (description "Check the attributes (first par) in the calling form against the attribute definitions taken from the DTD file (second par).
The first parameter, attribute, is the attributes of the calling form, on property list form:
(a1 v1 ... an vn). ai is a symbol and vi is a string.
The second parameter dtd-attribute-definition is the attributes as defined
in the dtd for the element in question. The third parameter number-of-req-attributes is the number
of required attributes in dtd-attr-definitions. The fourth parameter, tag-name, is the
name of the enclosing tag. dtd-attribute-definition is a list of 
triples (attr-name attr-type require-status). attr-name is a string, attr-type is
a string or a list of strings (possibilities), and require-status is a string
such as \"#IMPLIED\" or \"#REQUIRED\"
") (title "xml-check-attributes!") (form (xml-check-attributes! attributes dtd-attribute-definition number-of-req-attributes tag-name))) ((kind "manual-page") (description "The definition of the procedure that reports validation errors.
The default value is display-xml-warning, which issues non-fatal warning messages.
Alternative value: laml-error (fatal error messaging).
") (title "xml-check-error") (form xml-check-error)) ((kind "manual-section") (section-title "Rendering functions and procedures.") (section-body "The functions and procedures in this section transform the internal document representation
(abstract syntax trees) to a textual form (text strings).

")) ((kind "manual-page") (parameters (parameter "xml-clause" "an AST") (parameter "output-port" "an open output port") (parameter "prolog" "The symbol prolog, in which case (standard-prolog) is inserted, or a prolog string to be inserted") (parameter "epilog" "The symbol epilog in which case (standard-epilog) is inserted, or a epilog string to be inserted")) (description "Render the XML clause (an AST) to output-port.
output-port is assumed to be open. output-port will not be closed by this procedure.") (form "(render-to-output xml-clause output-port [prolog epilog])") (title "render-to-output-port")) ((kind "manual-page") (parameters (parameter "xml-clause" "an AST") (parameter "prolog" "The symbol prolog, in which case (standard-prolog) is inserted, or a prolog string to be inserted") (parameter "epilog" "The symbol epilog in which case (standard-epilog) is inserted, or a epilog string to be inserted")) (description "Render the xml-clause (an AST) and return the rendered string") (form "(render xml-clause [prolog epilog])") (title "xml-render")) ((kind "manual-section") (section-title "Other useful functions.") (section-body "
In this section there are non-mirror functions which are useful in in the context of XML and LAML.

")) ((kind "manual-page") (description "Define partial attributes and element contents of element and return a new element function
with the attributes and contents partially fixed.
attributes-and-contents is of the same form as the parameters to a LAML surface mirror functions.
In fact, attributes-and-contents are just appended to the actual parameters to the modified.") (example "(define a-main (modify-element a 'target \"main\"))") (returns "an attribute-modified mirror function") (title "xml-modify-element") (form (xml-modify-element element . attributes-and-contents))) ((kind "manual-page") (description "Convert an abtract syntax tree to a parse tree.
Abstract syntax trees are produced by the validating mirror functions.
Parse trees are used as an internal format in the HTML and the XML pretty printing procedures.
You can use the function pretty-print-html-parse-tree on the parse tree returned by ast-to-parse-tree.") (pre-condition "The LAML tool html-support (for parsing and pretty printing) must be loaded for this function to work.") (misc "To load html-support: <kbd>(laml-tool-load \"xml-html-support/html-support.scm\")</kbd>") (title "ast-to-parse-tree") (form (ast-to-parse-tree ast))))